    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------------------
    028     * AbstractIntervalXYDataset.java
    029     * ------------------------------
    030     * (C) Copyright 2004-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited).
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 05-May-2004 : Version 1 (DG);
    038     * 15-Jul-2004 : Switched getStartX() and getStartXValue() methods and
    039     *               others (DG);
    040     * 18-Aug-2004 : Moved from org.jfree.data --> org.jfree.data.xy (DG);
    041     *
    042     */
    043
    044    package org.jfree.data.xy;
    045
    046
    047    /**
    048     * An base class that you can use to create new implementations of the
    049     * {@link IntervalXYDataset} interface.
    050     */
    051    public abstract class AbstractIntervalXYDataset extends AbstractXYDataset
    052            implements IntervalXYDataset {
    053
    054        /**
    055         * Returns the start x-value (as a double primitive) for an item within a
    056         * series.
    057         *
    058         * @param series  the series index (zero-based).
    059         * @param item  the item index (zero-based).
    060         *
    061         * @return The value.
    062         */
    063        public double getStartXValue(int series, int item) {
    064            double result = Double.NaN;
    065            Number x = getStartX(series, item);
    066            if (x != null) {
    067                result = x.doubleValue();
    068            }
    069            return result;
    070        }
    071
    072        /**
    073         * Returns the end x-value (as a double primitive) for an item within a
    074         * series.
    075         *
    076         * @param series  the series index (zero-based).
    077         * @param item  the item index (zero-based).
    078         *
    079         * @return The value.
    080         */
    081        public double getEndXValue(int series, int item) {
    082            double result = Double.NaN;
    083            Number x = getEndX(series, item);
    084            if (x != null) {
    085                result = x.doubleValue();
    086            }
    087            return result;
    088        }
    089
    090        /**
    091         * Returns the start y-value (as a double primitive) for an item within a
    092         * series.
    093         *
    094         * @param series  the series index (zero-based).
    095         * @param item  the item index (zero-based).
    096         *
    097         * @return The value.
    098         */
    099        public double getStartYValue(int series, int item) {
    100            double result = Double.NaN;
    101            Number y = getStartY(series, item);
    102            if (y != null) {
    103                result = y.doubleValue();
    104            }
    105            return result;
    106        }
    107
    108        /**
    109         * Returns the end y-value (as a double primitive) for an item within a
    110         * series.
    111         *
    112         * @param series  the series (zero-based index).
    113         * @param item  the item (zero-based index).
    114         *
    115         * @return The value.
    116         */
    117        public double getEndYValue(int series, int item) {
    118            double result = Double.NaN;
    119            Number y = getEndY(series, item);
    120            if (y != null) {
    121                result = y.doubleValue();
    122            }
    123            return result;
    124        }
    125
    126    }